import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

public class clock
{
/*
    6
   5 4
    3
   2 1
    0

*/

  final static public int DIG0 = 0x77; // 0111 0111
  
  final static public int DIG1 = 0x12; // 0001 0010
  
  final static public int DIG2 = 0x5D; // 0101 1101
  
  final static public int DIG3 = 0x5B; // 0101 1011
  
  final static public int DIG4 = 0x3A; // 0011 1010
  
  final static public int DIG5 = 0x6B; // 0110 1011
  
  final static public int DIG6 = 0x6F; // 0110 1111
  
  final static public int DIG7 = 0x52; // 0101 0010
  
  final static public int DIG8 = 0x7F; // 0111 1111
  
  final static public int DIG9 = 0x7B; // 0111 1011
  
  final static public int[] DIG = {DIG0, DIG1, DIG2, DIG3, DIG4, DIG5, DIG6, DIG7, DIG8, DIG9};
  
  
  public enum DigSt {ON, OFF, AMB};
  
  
  static public class DigitNumber
  {
    DigSt dig[] = new DigSt[7];
    
    public DigitNumber()
    {
      reset();
    }
    
    public void reset()
    {
      for(int i = 0; i < dig.length; i++)
        dig[i] = DigSt.AMB;
    }
    
    public int getDig()
    {
      int n = 0;
      
      for(int i = 0; i < dig.length; i++)
      {
        if(dig[i] == DigSt.ON)
          n |= (1 << i);
      }
      
      return n;
    }
    
    public boolean getDigit(int c)
    {
      return (dig[c] == DigSt.ON);
    }
    
    public void setDigit(int c, boolean b)
    {
      dig[c] = (b ? DigSt.ON : DigSt.OFF);
    }
    
    public void setAmbDigit(int c)
    {
      dig[c] = DigSt.AMB;
    }
    
    public boolean hasAmbDigit()
    {
      for(int i = 0; i < dig.length; i++)
      {
        if(dig[i] == DigSt.AMB)
          return true;
      }
      
      return false;
    }
    
    public int getAvailable()
    {
      int a = 0;
      boolean b;
      
      iCycle: 
      for(int i = 0; i < DIG.length; i++)
      {
        for(int i2 = 0; i2 < dig.length; i2++)
        {
          b = (((DIG[i] >> i2) & 1) == 1);
          
          if(dig[i2] == DigSt.ON)
          {
            if(!b)
              continue iCycle;
          }
          else if(dig[i2] == DigSt.OFF)
          {
            if(b)
              continue iCycle;
          }
        }
        
        a |= (1 << i);       
      }
      
      return a;
    }
    
    public int getVariants(int mask)
    {
      int a = (getAvailable() & mask);
      int v = 0;
      
      for(int i = 0; i <= 9; i++)
      {
        if(((a >> i) & 1) == 1)
          v++;
      }
      
      return v;
    }
    
    public int getValue()
    {
      int d = getDig();
      
      for(int i = 0; i < DIG.length; i++)
      {
        if(d == DIG[i])
          return i;
      }
      
      return -1;
    }
    
    public char getCharValue()
    {
      int value = getValue();
      return ((value < 0) ? '?' : Integer.toString(value).charAt(0));
    }
  }
  
  static public class Time
  {
    DigitNumber digits[] = new DigitNumber[4];
    
    public Time()
    {
      for(int i = 0; i < 4; i++)
        digits[i] = new DigitNumber();
    }
    
    public DigitNumber getDigit(int i)
    {
      return digits[i];
    }
    
    public void print()
    {
      boolean b = false;
      
      for(int i = 0; i < 4; i++)
        b |= digits[i].hasAmbDigit();
      
      if(b)
      {
        int v = 1;
        v *= digits[0].getVariants(0x0007);
        v *= digits[1].getVariants(0xFFFF);
        v *= digits[2].getVariants(0x003F);
        v *= digits[3].getVariants(0xFFFF);
        
        System.out.println("ambiguous, "+v+" possibilities");
      }
      else
        System.out.println(digits[0].getCharValue()+""+digits[1].getCharValue()+":"+digits[2].getCharValue()+""+digits[3].getCharValue());
    }
    
    public void print(Time time, int min, int max)
    {
      boolean b = false;
      
      int firstDigit = (time.getDigit(0).hasAmbDigit() ? 0 : time.getDigit(0).getValue());
      int minutes = (((firstDigit*10)+time.getDigit(1).getValue())*60)+((time.getDigit(2).getValue()*10)+time.getDigit(3).getValue());
      
      int minMinutes = (min+minutes);
      int maxMinutes = (max+minutes);
      
      int minHours = (minMinutes / 60);
      int maxHours = (maxMinutes / 60);
      
      minMinutes -= (minHours*60);
      maxMinutes -= (maxHours*60);
      
      int minD[] = new int[4];
      int maxD[] = new int[4];
      
      minD[0] = (minHours / 10);
      minD[1] = minHours-(minD[0]*10);
      minD[2] = (minMinutes / 10);
      minD[3] = minMinutes-(minD[2]*10);
      
      maxD[0] = (maxHours / 10);
      maxD[1] = maxHours-(maxD[0]*10);
      maxD[2] = (maxMinutes / 10);
      maxD[3] = maxMinutes-(maxD[2]*10);
      
      System.out.println("MIN "+minD[0]+""+minD[1]+":"+minD[2]+""+minD[3]);
      System.out.println("MAX "+maxD[0]+""+maxD[1]+":"+maxD[2]+""+maxD[3]);
      
      for(int i = 0; i < 4; i++)
        b |= digits[i].hasAmbDigit();
      
      if(b)
      {
        int v = 0;
        
        int a0 = (digits[0].getAvailable() & 0x0007);
        int a1 = (digits[1].getAvailable() & 0xFFFF);
        int a2 = (digits[2].getAvailable() & 0x003F);
        int a3 = (digits[3].getAvailable() & 0xFFFF);
        
        int c[] = new int[4];
        int last[] = new int[4];
        int actHours, actMinutes;
        
        for(int x = 0; x <= 2; x++)
        {
          if(((a0 >> x) & 1) != 1)
            continue; 
          
          c[0] = x;
          
          for(int y = 0; y <= 9; y++)
          {
            if(((a1 >> y) & 1) != 1)
              continue; 
          
            c[1] = y;
          
            for(int z = 0; z <= 5; z++)
            {
              if(((a2 >> z) & 1) != 1)
                continue; 
          
               c[2] = z;
          
              for(int w = 0; w <= 9; w++)
              {
                if(((a3 >> w) & 1) != 1)
                  continue; 
          
                c[3] = w;
          
                actHours = (c[0]*10)+c[1];
                actMinutes = (c[2]*10)+c[3];
                
                if((actHours >= minHours) && (actHours <= maxHours))
                {
                  if((actMinutes >= minMinutes) && (actMinutes <= maxMinutes))
                  {
                    last[0] = c[0];
                    last[1] = c[1];
                    last[2] = c[2];
                    last[3] = c[3];
                    v++;
                  }
                }
              }
            }
          }
        }
        
        System.out.println("ambiguous, "+v+" possibilities");
      }
      else
        System.out.println(digits[0].getCharValue()+""+digits[1].getCharValue()+":"+digits[2].getCharValue()+""+digits[3].getCharValue());
    }
  }
  
  static void printDig(int d)
  {
    System.out.println( ((d & 0x40) == 0x40) ? " - " : " . ");
    
    System.out.print(   ((d & 0x20) == 0x20) ? "| " : ". ");
    System.out.println( ((d & 0x10) == 0x10) ? "|" : ".");
    
    System.out.println( ((d & 0x08) == 0x08) ? " - " : " . ");
    
    System.out.print(   ((d & 0x04) == 0x04) ? "| " : ". ");
    System.out.println( ((d & 0x02) == 0x02) ? "|" : ".");
    
    System.out.println( ((d & 0x01) == 0x01) ? " - " : " . ");
  }
  
  
  final static public int DNI[] = {0, 1, 2, 3, 0, 0, 1, 1, 2, 2, 3, 3, 0, 1, 2, 3, 0, 0, 1, 1, 2, 2, 3, 3, 0, 1, 2, 3};
  final static public int DNC[] = {6, 6, 6, 6, 5, 4, 5, 4, 5, 4, 5, 4, 3, 3, 3, 3, 2, 1, 2, 1, 2, 1, 2, 1, 0, 0, 0, 0};
  
  static public void readDigits(String s, Time time)
  {
    for(int i = 0; i < 4; i++)
      time.getDigit(i).reset();
      
    char c;
    StringBuilder sb = new StringBuilder(28);
    for(int i = 0; i < s.length(); i++)
    {
      c = s.charAt(i);
      
      if((c == '.') || (c == '-') || (c == '|') || (c == '?'))
        sb.append(c);
    }
    
    s = sb.toString();
    
    int ci = 0; //pořadí článku čísla dle Figure 4 (o jedno menší, -1)
    for(int i = 0; i < 28; i++)
    {
      if((s.length() == 21) && (DNI[i] == 0)) //pro zadání bez nuly
        continue;
        
      c = s.charAt(ci);
      
      if(c != '?')
        time.getDigit(DNI[i]).setDigit(DNC[i], ((c == '-') || (c == '|')));
        
      ci++;
    }
  }
  
  
  static public void main(String args[])
  {
    Scanner in = new Scanner(System.in);
    
    Time times[] = new Time[100];
  
    for(int i = 0; i < times.length; i++)
      times[i] = new Time();
    
    StringBuilder sb;
    int min = 0;
    int max = 0;
    
    while(in.hasNextInt())
    {
      int s = in.nextInt();
      
      if(s == 0)
        break;
        
      System.out.println(s);
        
      for(int i = 0; i < s; i++)
      {
        if(i > 0)
        {
          min = in.nextInt();
          max = in.nextInt();
          System.out.println("MINMAX "+min+" "+max);
        }
        
        sb = new StringBuilder();
      
        int line = 0;
        while(in.hasNextLine())
        {
          sb.append(in.nextLine());
          
          line++;
          
          if(line == 6)
            break;
        }
      
        readDigits(sb.toString(), times[i]);
        
        if(i > 0)
          times[i].print(times[i-1], min, max);
        else
          times[i].print();
      }
      
    }
    
    
    System.exit(0);
  }
}

